#include "3d.h"

#define epsi 0.01

struct Pnt	sourcepnt[maxpnt];
struct Seg	sourceseg[maxseg];
struct Pol	sourcepol[maxpol];
struct Noeud	noeuds[maxnoeud];

struct Pntw	bufpnt[maxpnt];
struct Seg	bufseg[maxseg];
struct Polw	bufpol[maxpol];

int	nbpntsource;
int	nbsegsource;
int	nbpolsource;
int	nbnoeud;
int	nbtrait;

float	trait[maxseg*4];

int ajouteseg(int n1, int n2)
	{
		int	i;

	for(i=0;i<nbsegsource;i++)
	  {
	  if ((sourceseg[i].n1==n1)&&(sourceseg[i].n2==n2)) return i;
	  if ((sourceseg[i].n1==n2)&&(sourceseg[i].n2==n1)) return 0x8000+i;
	  }
	sourceseg[nbsegsource].n1=n1;
	sourceseg[nbsegsource++].n2=n2;
	return nbsegsource-1;
	}

int inidata(char *name)
	{
	FILE	*fichier;
	int	i,j;
	float	valeur;
	int	n1,n2,n3;
	int	complex;

	fichier=fopen(name,"r");
	if (fichier==NULL) return 0;

	fscanf(fichier,"%d",&nbpntsource);  
	for(i=0;i<nbpntsource;i++)
		fscanf(fichier,"%f%f%f",&sourcepnt[i].x
			,&sourcepnt[i].y,&sourcepnt[i].z);

	nbsegsource=0;
	fscanf(fichier,"%d",&nbpolsource);
	for(i=0;i<nbpolsource;i++)
		{
		fscanf(fichier,"%d%d%d%d",&sourcepol[i].type
			,&sourcepol[i].col,&sourcepol[i].ns
			,&sourcepol[i].frere);
		if(sourcepol[i].ns==2)
			{
			fscanf(fichier,"%d%d",&n1,&n2);
			sourcepol[i].nums[0]=ajouteseg(n1,n2);
			}
		if(sourcepol[i].ns==3)
			{
			fscanf(fichier,"%d%d%d",&n1,&n2,&n3);
			sourcepol[i].nums[0]=ajouteseg(n1,n2);
			sourcepol[i].nums[1]=ajouteseg(n2,n3);
			sourcepol[i].nums[2]=ajouteseg(n3,n1);
			vnorm(&sourcepnt[n1],&sourcepnt[n2],&sourcepnt[n3]
					,&sourcepol[i].norm);
			}
		}

	complex=0;
	fscanf(fichier,"%d",&nbnoeud);
	for(i=0;i<nbnoeud;i++)
		{
		fscanf(fichier,"%d%d%d%f%f%f%f"
			,&noeuds[i].firstp, &noeuds[i].filsp, &noeuds[i].filsm
			,&noeuds[i].a,&noeuds[i].b,&noeuds[i].c,&noeuds[i].d);
		if (noeuds[i].filsp!=-1) complex++;
		}

	fclose(fichier);

	printf("nb pnt     : %d\nnb seg     : %d\nnb pol     : %d\n"
			,nbpntsource,nbsegsource,nbpolsource);
	printf("nb noeuds  : %d\ncomplexite : %d\n", nbnoeud, complex);
	return 1;

	}

void iniimage(observ obs, int modegraph)
	{
	if (modegraph==0)
		XSetState(obs->display,obs->gc,pixels[0],0,GXcopy,AllPlanes);
	else	if (modegraph>=3)
			XSetForeground(obs->display,obs->gc,white);
		else
			XSetForeground(obs->display,obs->gc,black);

	XFillRectangle(obs->display,obs->dessin,obs->gc
				,0,0,obs->sx*2,obs->sy*2);

	bufpnt[0].xp=obs->sx; bufpnt[0].yp=-obs->sy;
	bufpnt[1].xp=obs->sx; bufpnt[1].yp=obs->sy;
	bufpnt[2].xp=-obs->sx; bufpnt[2].yp=obs->sy;
	bufpnt[3].xp=-obs->sx; bufpnt[3].yp=-obs->sy;
	bufpnt[0].state=9;
	bufpnt[1].state=10;
	bufpnt[2].state=6;
	bufpnt[3].state=5;
	}

void rotation(pnt source, int nbpnt, pntw dest, int offp, pass pobs
		, observ obs)
	{
		int	i,a;
		float	xs,ys,zs;
		float	x,y,z;
		float	zph,zps;
		pnt	si;
		pntw	di;

	for(i=0;i<nbpnt;i++)
		{
		si=&source[i];
		di=&dest[i+offp];
		xs=si->x;
		ys=si->y;
		zs=si->z;
		di->p.x=x
		  = pobs->m.aa*xs + pobs->m.ab*ys + pobs->m.ac*zs + pobs->v.xv;
		di->p.y=y
		  = pobs->m.ba*xs + pobs->m.bb*ys + pobs->m.bc*zs + pobs->v.yv;
		di->p.z=z
		  = pobs->m.ca*xs + pobs->m.cb*ys + pobs->m.cc*zs + pobs->v.zv;
		di->zphi=zph= z*obs->phi;
		di->zpsi=zps= z*obs->psi;
		a=0;
		if (y<=-zps)	a+=1;
		if (y>=zps)	a+=2;
		if (x<=-zph)	a+=4;
		if (x>=zph)	a+=8;
		if((di->state=a)==0)
			{
			di->xp=(x*obs->dist) /z;
			di->yp=(y*obs->dist) /z;
			}
		}
	}

int calcinter(int ax, int nx, pntw p, pntw q, pntw bp, int pnew, observ obs)
	{
		float	x,y;
		float	a,b,c,bg,bd;

	if (ax==0) return nx;

	if (ax&3)	a=(p->p.z * q->p.y)-(q->p.z * p->p.y);
	if ((ax&1)&&(a!=0))
		  {
		  bg= q->p.y + q->zpsi;
		  bd= p->p.y + p->zpsi;
		  b=bg-bd;
		if (((a<0)&&(b<0))||((a>0)&&(b>0)))
		  {
		  x=(obs->dist*((p->p.x * bg)-(q->p.x * bd)))/a;
		if ((x<=obs->sx)&&(x>=-obs->sx))
			{
				pntw	bn=&bp[pnew];

			bn->p=bp[nx].p;
			bn->state=1;
			bn->xp=x;
			bn->yp=-obs->sy;
			return pnew;
			}
		  }
		  }
	if ((ax&2)&&(a!=0))
		  {
		  bg= q->p.y - q->zpsi;
		  bd= p->p.y - p->zpsi;
		  b=bg-bd;
		if (((a<0)&&(b<0))||((a>0)&&(b>0)))
		  {
		  x=(obs->dist*((p->p.x * bg)-(q->p.x * bd)))/a;
		if ((x<=obs->sx)&&(x>=-obs->sx))
			{
				pntw	bn=&bp[pnew];

			bn->p=bp[nx].p;
			bn->state=2;
			bn->xp=x;
			bn->yp=obs->sy;
			return pnew;
			}
		  }
		  }

	if (ax&12)	a=(p->p.z * q->p.x)-(q->p.z * p->p.x);
	if ((ax&4)&&(a!=0))
		  {
		  bg= q->p.x + q->zphi;
		  bd= p->p.x + p->zphi;
		  b=bg-bd;
		if (((a<0)&&(b<0))||((a>0)&&(b>0)))
		  {
		  y=(obs->dist*((p->p.y * bg)-(q->p.y * bd)))/a;
		if ((y<=obs->sy)&&(y>=-obs->sy))
			{
				pntw	bn=&bp[pnew];

			bn->p=bp[nx].p;
			bn->state=4;
			bn->xp=-obs->sx;
			bn->yp=y;
			return pnew;
			}
		  }
		  }
	if ((ax&8)&&(a!=0))
		  {
		  bg= q->p.x - q->zphi;
		  bd= p->p.x - p->zphi;
		  b=bg-bd;
		if (((a<0)&&(b<0))||((a>0)&&(b>0)))
		  {
		  y=(obs->dist*((p->p.y * bg)-(q->p.y * bd)))/a;
		if ((y<=obs->sy)&&(y>=-obs->sy))
			{
				pntw	bn=&bp[pnew];

			bn->p=bp[nx].p;
			bn->state=8;
			bn->xp=obs->sx;
			bn->yp=y;
			return pnew;
			}
		  }
		  }
	return -1;
	}


int interline(seg source, int nbseg, pntw bpnt, seg dest, int pnew
		, int offp, int offl, observ obs)
	{
		int	i,n1,n2;
		int	a1,a2;
		int	res;
		seg	di,si;

	for(i=0;i<nbseg;i++)
	  {
	  si=&source[i];
	  di=&dest[i+offl];
	  di->n1=-1;
	  n1=si->n1+offp;
	  n2=si->n2+offp;
	  a1=bpnt[n1].state;
	  a2=bpnt[n2].state;
	if((a1&a2)==0)
		{
		res=calcinter(a1,n1,&bpnt[n1],&bpnt[n2],bpnt,pnew,obs);
		if (res!=-1)
		{
		di->n1=res;
		if (res==pnew) pnew++;
		res=calcinter(a2,n2,&bpnt[n1],&bpnt[n2],bpnt,pnew,obs);
		if (res!=-1)
			{
			di->n2=res;
			if (res==pnew) pnew++;
			}
			else
			di->n1=-1;
		}
		}
	  }
	return pnew;
	}

float det2(pntw p, pntw q)
	{
	return (p->p.x*q->p.y - p->p.y*q->p.x);
	}

void coupol(pol source, int nbpol, pntw bufp, seg srcs, seg bufs, polw dest
		,pass pobs, int offp, int offl, int offpo, observ obs)
	{
		int	i,j,k,a,b;
		float	xs,ys,zs;
		float	x,y,z;
		float	oan,cl;
		pntw	p1,p2,p3;
		int	ks,kd;
		int	nf,ln,n1,n2;
		pol	si;
		polw	di;

	for(i=0;i<nbpol;i++)
	if (source[i].ns!=3)
		{
		si=&source[i];
		di=&dest[i+offpo];
		di->frere=si->frere+offpo;
		di->col=si->col;
		xs=si->norm.xv;
		ys=si->norm.yv;
		zs=si->norm.zv;
		di->norm.xv=x
		  = pobs->m.aa*xs + pobs->m.ab*ys + pobs->m.ac*zs;
		di->norm.yv=y
		  = pobs->m.ba*xs + pobs->m.bb*ys + pobs->m.bc*zs;
		di->norm.zv=z
		  = pobs->m.ca*xs + pobs->m.cb*ys + pobs->m.cc*zs;
		if(bufs[j=(si->nums[0]&0x7fff)+offl].n1!=-1)
			{
			di->pn[0]=bufs[j].n1;
			di->pn[1]=bufs[j].n2;
			di->np=2;
			di->type=si->type;
			}
		else	di->type=-1;
		}
	else
		{
		si=&source[i];
		di=&dest[i+offpo];
		di->frere=si->frere+offpo;

		xs=si->norm.xv;
		ys=si->norm.yv;
		zs=si->norm.zv;
		di->norm.xv=x
		  = pobs->m.aa*xs + pobs->m.ab*ys + pobs->m.ac*zs;
		di->norm.yv=y
		  = pobs->m.ba*xs + pobs->m.bb*ys + pobs->m.bc*zs;
		di->norm.zv=z
		  = pobs->m.ca*xs + pobs->m.cb*ys + pobs->m.cc*zs;
		p1=&bufp[srcs[(k=si->nums[0])&0x7fff].n1+offp];
		di->oan=oan=x*p1->p.x + y*p1->p.y + z*p1->p.z;
		if (oan>0) cl=(z*15.)+16.+32*si->col;
			else cl=16.+32.*si->col-(z*15.);
		di->col=cl;
		ks=0;
		kd=0;
		while((ks<3)
		  &&(bufs[((j=si->nums[ks])&0x7fff)+offl].n1==-1)) ks++;
		if (ks==3)
			{
			di->type=-1;
			if (((z>0)&&(oan>0))||((z<0)&&(oan<0)))
			  {
			  if (k&0x8000)
				{
				p2=p1;
				p1=&bufp[srcs[k&0x7fff].n2+offp];
				}
			  else p2=&bufp[srcs[k].n2+offp];
			  if ((k=si->nums[1])&0x8000)
				p3=&bufp[srcs[k&0x7fff].n1+offp];
				else
				p3=&bufp[srcs[k].n2+offp];
			  if ((p1->state|p2->state|p3->state)==15)
				{
					float	d1,d2,d3;
				d1=det2(p1,p2);
				d2=det2(p2,p3);
				d3=det2(p3,p1);
				if (  ((d1>0)&&(d2>0)&&(d3>0))
					||((d1<0)&&(d2<0)&&(d3<0))  )
					{
					di->pn[0]=0;
					di->pn[1]=1;
					di->pn[2]=2;
					di->pn[3]=3;
					di->np=4;
					di->type=si->type;
					}
				}
			  }
			}
		else
			{
			k=(j&0x7fff)+offl;
			if (j&0x8000)
				{
				nf=bufs[k].n2;
				ln=bufs[k].n1;
				}
			else
				{
				nf=bufs[k].n1;
				ln=bufs[k].n2;
				}
			di->pn[kd++]=nf;
			di->pn[kd++]=ln;
		while(ln!=nf)
		{
		ks++;
		while((ks<3)
		  &&(bufs[((j=si->nums[ks])&0x7fff)+offl].n1==-1)) ks++;
		if (ks==3) n1=nf;
		else
		  {
		  k=(j&0x7fff)+offl;
		  if (j&0x8000)
			{
			n1=bufs[k].n2;
			n2=bufs[k].n1;
			}
		  else
			{
			n1=bufs[k].n1;
			n2=bufs[k].n2;
			}
		  }
		if (n1!=ln)
		  {
		  a=bufp[ln].state;
		  b=bufp[n1].state;
		  if ((a)&&(b))
		   {
		   while((a&b)==0)
		    {
		    if (oan>0)
			{
			switch(a)	{
			case 1 :
				di->pn[kd++]=0;
				a=8;
				break;
			case 2 :
				di->pn[kd++]=2;
				a=4;
				break;
			case 4 :
				di->pn[kd++]=3;
				a=1;
				break;
			case 8 :
				di->pn[kd++]=1;
				a=2;
				break;
			default :
				a=b;
				break;
				}
			}
		  else
			{
			switch(a)	{
			case 1 :
				di->pn[kd++]=3;
				a=4;
				break;
			case 2 :
				di->pn[kd++]=1;
				a=8;
				break;
			case 4 :
				di->pn[kd++]=2;
				a=2;
				break;
			case 8 :
				di->pn[kd++]=0;
				a=1;
				break;
			default :
				a=b;
				break;
				}
			}
		  }
		}
		  if (n1==nf) n2=nf;
			else
			di->pn[kd++]=n1;
		  }

		if (n2!=nf) di->pn[kd++]=n2;
		ln=n2;   
		}
		di->np=kd;
		if (oan<0)
			for(j=0;j<kd-1-j;j++)
				{
				k=di->pn[j];
				di->pn[j]=di->pn[kd-1-j];
				di->pn[kd-1-j]=k;
				}
		if (kd) di->type=si->type;
			else
			di->type=-1;

			}
		}
	}

void affichefil(observ obs,int modegraph)
	{
		int	i,n1,n2;

	nbtrait=0;
	if (modegraph!=3)
		XSetForeground(obs->display,obs->gc,white);
	else
		XSetForeground(obs->display,obs->gc,black);
	for(i=0;i<nbsegsource;i++)
		{
		n1=bufseg[i].n1;
		n2=bufseg[i].n2;
		if (n1!=-1)
		{
		XDrawLine(obs->display,obs->dessin,obs->gc
			,obs->sx+bufpnt[n1].xp
			,obs->sy-bufpnt[n1].yp
			,obs->sx+bufpnt[n2].xp
			,obs->sy-bufpnt[n2].yp);
		trait[nbtrait*4]=bufpnt[n1].xp;
		trait[nbtrait*4+1]=bufpnt[n1].yp;
		trait[nbtrait*4+2]=bufpnt[n2].xp;
		trait[nbtrait*4+3]=bufpnt[n2].yp;
		nbtrait++;
		}
		}
	}

int affpol(int i,polw p, observ obs)
	{
		int	j,k,l;
		int	oldtr;
		float	*tr,*trb;
		float	lam[4];
		int	ni,fla,flb;
		float	sgna,sgnb;
		float	kf,lf,deno;
		pntw	pk,pl;

	oldtr=nbtrait;

	for(j=0;j<oldtr;j++)
		{
		tr=&trait[j*4];
		ni=0;
		fla=flb=0;
		for(k=0;k<p->np;k++)
			{
			l=k+1;
			if (l>=p->np) l=0;
			pk=&bufpnt[p->pn[k]];
			pl=&bufpnt[p->pn[l]];

		if ((pk->xp!=pl->xp)||(pk->yp!=pl->yp))
			{
			sgna=(pk->xp-tr[0])*(pl->yp-pk->yp)
				-(pk->yp-tr[1])*(pl->xp-pk->xp);
			if ((sgna<epsi)&&(sgna>-epsi))
						{
						sgna=0;
						if (fla==0) fla=1;
						}
			if (sgna<0) fla=2;
			
			sgnb=(pk->xp-tr[2])*(pl->yp-pk->yp)
				-(pk->yp-tr[3])*(pl->xp-pk->xp);
			if ((sgnb<epsi)&&(sgnb>-epsi))
						{
						sgnb=0;
						if (flb==0) flb=1;
						}
			if (sgnb<0) flb=2;

			if ((sgna!=0)&&(sgnb!=0))
			{
			deno=(tr[2]-tr[0])*(pl->yp-pk->yp)
				-(tr[3]-tr[1])*(pl->xp-pk->xp);
			if (deno!=0)
			  {
			  kf=sgna/deno;
			  if ((kf>0)&&(kf<1))
				{
				lf=((pk->xp-tr[0])*(tr[3]-tr[1])
					-(pk->yp-tr[1])*(tr[2]-tr[0]))/deno;
				if ((lf>0)&&(lf<1)) lam[ni++]=kf;
				if (ni>2) ni=2;
				}
			  }
			}

			}

			}
		if ((fla<2)&&(flb<2))
			{
			for (k=j;k<nbtrait-1;k++)
				{
				trait[k*4]=trait[(k+1)*4];
				trait[k*4+1]=trait[(k+1)*4+1];
				trait[k*4+2]=trait[(k+1)*4+2];
				trait[k*4+3]=trait[(k+1)*4+3];
				}
			nbtrait--;
			oldtr--;
			j--;
			}
		if ((fla<2)&&(flb==2)&&(ni))
				{
				tr[0]+=lam[0]*(tr[2]-tr[0]);
				tr[1]+=lam[0]*(tr[3]-tr[1]);
				}
		if ((flb<2)&&(fla==2)&&(ni))
				{
				tr[2]=tr[0]+lam[0]*(tr[2]-tr[0]);
				tr[3]=tr[1]+lam[0]*(tr[3]-tr[1]);
				}
		if ((fla==2)&&(flb==2)&&(ni>1))
			{
			if (lam[1]<lam[0])
				{
				lam[2]=lam[0];
				lam[0]=lam[1];
				lam[1]=lam[2];
				}
			trb=&trait[(nbtrait++)*4];
			trb[0]=tr[0]+lam[1]*(tr[2]-tr[0]);
			trb[1]=tr[1]+lam[1]*(tr[3]-tr[1]);
			trb[2]=tr[2];
			trb[3]=tr[3];
			tr[2]=tr[0]+lam[0]*(tr[2]-tr[0]);
			tr[3]=tr[1]+lam[0]*(tr[3]-tr[1]);
			}
		}

	j=p->np;
	if (j==2) j=1;
	for(k=0;k<j;k++)
		{
		l=k+1;
		if (l>=p->np) l=0;
		pk=&bufpnt[p->pn[k]];
		pl=&bufpnt[p->pn[l]];
		if (((pk->state&pl->state)&15)==0)
			{
			trb=&trait[(nbtrait++)*4];
			trb[0]=pk->xp;
			trb[1]=pk->yp;
			trb[2]=pl->xp;
			trb[3]=pl->yp;
			}
		}

	}

XPoint points[20];

void recaffiche(int no, observ obs, vec v, int modegraph)
	{
		polw	p;
		noeud	n;
		int	i,j;
		float	k;

	n=&noeuds[no];

	i=n->firstp;
	while(i!=-1)
	  {
	  p=&bufpol[i];
	  if((p->type==0)&&(p->oan<0))
		{
		if (modegraph==4) affpol(i,p,obs);
		else
		  {
		  if (modegraph==2)
			XSetForeground(obs->display,obs->gc,black);
			else
			XSetState(obs->display,obs->gc
				,pixels[p->col],0,GXcopy,AllPlanes);
		  for(j=0;j<p->np;j++)
			{
			points[j].x=obs->sx+bufpnt[p->pn[j]].xp;
			points[j].y=obs->sy-bufpnt[p->pn[j]].yp;
			}
		  if(p->np>2)
		  {
		  XFillPolygon(obs->display,obs->dessin,obs->gc,points,p->np
				,Convex,CoordModeOrigin);
		  if (modegraph==2)
			{
			points[p->np]=points[0];
			XSetForeground(obs->display,obs->gc,white);
			XDrawLines(obs->display,obs->dessin,obs->gc,points
				,p->np+1,CoordModeOrigin);
			}
		  }
		  }
		}
          i=p->frere;
	  }

	if (n->filsp!=-1)
		{
		if (n->filsm!=-1)
			{
			k=v->xv*n->a + v->yv*n->b + v->zv*n->c + n->d ;
			if (k>0){
				recaffiche(n->filsp,obs,v,modegraph);
				recaffiche(n->filsm,obs,v,modegraph);
				}
				else
				{
				recaffiche(n->filsm,obs,v,modegraph);
				recaffiche(n->filsp,obs,v,modegraph);
				}
			}
			else
			recaffiche(n->filsp,obs,v,modegraph);
		}

 	i=n->firstp;
	while(i!=-1)
	  {
	  p=&bufpol[i];
	  if((p->type==0)&&(p->oan>0))
		{
		if (modegraph==4) affpol(i,p,obs);
		else
		  {
		  if (modegraph==2)
			XSetForeground(obs->display,obs->gc,black);
			else
			XSetState(obs->display,obs->gc
				,pixels[p->col],0,GXcopy,AllPlanes);
		  for(j=0;j<p->np;j++)
			{
			points[j].x=obs->sx+bufpnt[p->pn[j]].xp;
			points[j].y=obs->sy-bufpnt[p->pn[j]].yp;
			}
		  if(p->np>2)
		  {
		  XFillPolygon(obs->display,obs->dessin,obs->gc,points,p->np
				,Convex,CoordModeOrigin);
		  if (modegraph==2)
			{
			points[p->np]=points[0];
			XSetForeground(obs->display,obs->gc,white);
			XDrawLines(obs->display,obs->dessin,obs->gc,points
				,p->np+1,CoordModeOrigin);
			}
		  }
		  }
		}
          i=p->frere;
	  }
     	}

void image3d(observ obs, pass passobs, int modegraph)
	{
		struct Vec	v;
		int		k;
		float		*trb;

	nbtrait=0;
	iniimage(obs, modegraph);

	tmulmatvec(&passobs->m, &passobs->v, &v);
	mulscalvec(-1.0, &v, &v);

	rotation(&sourcepnt[0],nbpntsource,&bufpnt[0]
			,4,passobs,obs);
	interline(&sourceseg[0],nbsegsource,&bufpnt[0],&bufseg[0],nbpntsource+4
			,4,0,obs);
	if ((modegraph==1)||(modegraph==3))
		affichefil(obs,modegraph);
		else
		{
		coupol(&sourcepol[0],nbpolsource,&bufpnt[0]
			,&sourceseg[0],&bufseg[0]
			,&bufpol[0],passobs,4,0,0,obs);
		recaffiche(0,obs,&v,modegraph);
		if (modegraph==4)
		  {
		  XSetForeground(obs->display,obs->gc,black);
		  for(k=0;k<nbtrait;k++)
			{
			trb=&trait[k*4];
			XDrawLine(obs->display,obs->dessin,obs->gc
				,obs->sx+trb[0],obs->sy-trb[1]
				,obs->sx+trb[2],obs->sy-trb[3]);
			}
		  }
		}
	}



