#include "3d.h"
#include "model.h"

int		black,white;
char		*nomstat=NULL;
Display		*display;
int		screen;
Colormap	cmap;
Visual		*visual;
Window		root,win[2],tools;
GC		gc;
PIXEL		*pixels;
Pixmap		dessin;

pass	pas[2];
observ	obs[2];
rotsph	rsph[2];
int	modegraph;
int	modedep;
int	modecroix;

void imagei(int i)
	{
		int	m=1;

	if (nbnoeud&&i) m=modegraph;
	image3d(obs[i],pas[i],m);
	if (modecroix) ajoutecroix(obs[i]);
	XCopyArea(display,dessin,win[i],gc
			,0,0,obs[i]->sx*2,obs[i]->sy*2,0,0);
	}

void clickg(int i, float x, float y)
	{
		int	r,m=1;

	if (nbnoeud&&i) m=modegraph;
	image3d(obs[i],pas[i],m);
	r=findnear(x,y);
	if (r!=-1) empile(r);
	ajoutecroix(obs[i]);
	XCopyArea(display,dessin,win[i],gc
			,0,0,obs[i]->sx*2,obs[i]->sy*2,0,0);
	imagei(1-i);
	afcourant();
	}

void clickm(int i, float x, float y)
	{
		int	r,m=1;

	if (nbnoeud&&i) m=modegraph;
	image3d(obs[i],pas[i],m);
	r=findnear(x,y);
	if (r!=-1) depilep(r);
	ajoutecroix(obs[i]);
	XCopyArea(display,dessin,win[i],gc
			,0,0,obs[i]->sx*2,obs[i]->sy*2,0,0);
	imagei(1-i);
	afcourant();
	}

void iniposition(observ obs, pass pb, rotsph rsph) 
	{
	obs->dist=400.;
	obs->sx=200.;
	obs->sy=200.;
	obs->phi=obs->sx/obs->dist;
	obs->psi=obs->sy/obs->dist;

	obs->display=display;
	obs->dessin=dessin;
	obs->gc=gc;

	rsph->th=MYPI/2.;
	rsph->ph=-MYPI/2.;
	rsph->rho=300.;
	convmat(rsph,pb);

	}

		
void main(int argc,char **argv)
	{

	XEvent	ev;
	int	xm,ym,xlm,ylm;
	int	i,i0,i1,it;
	int	ro,ve,bl,c;
	XColor	xc;
	char	*name="objet.dat";
	
	struct Pass	Pass[2];
	struct Observ	Obs[2];
	struct Rotsph	Rsph[2];

	int     gray;
	int	state;

	pixels=(PIXEL*)malloc((32*7+2)*sizeof(PIXEL));
	modegraph=0;
	modedep=0;
	modecroix=1;
	gray=0;

	for(i=0;i<argc;i++)
		{
		if(!strcmp(argv[i],"-d")) nomstat=argv[i+1];
		if(!strcmp(argv[i],"-mono")) modegraph=2;
		if(!strcmp(argv[i],"-easy")) modedep=1;
		if(!strcmp(argv[i],"-gray")) gray=1;
		if(!strcmp(argv[i],"-mod4")) modegraph=4;
		if(!strcmp(argv[i],"-h"))
			{
			printf("options :\n -d    : display \n");
			printf(" -mono : ecran mono\n");
			printf(" -easy : deplacement simplifie\n");
			printf(" -gray : palette grise\n");

			exit(1);	
			};

		}

	display=XOpenDisplay(nomstat);
	screen=DefaultScreen(display);
	visual=DefaultVisual(display,screen);
	cmap=DefaultColormap(display,screen);
	root=RootWindow(display,screen);
	black=BlackPixel(display,screen);
	white=WhitePixel(display,screen);
	gc=DefaultGC(display,screen);

	if (modegraph==0)
	{
	xc.flags=DoRed|DoGreen|DoBlue;
	if (!XAllocColorCells(display,cmap,False,0,0,pixels,32*7))
		{
		cmap=XCreateColormap(display,RootWindow(display,screen)
			,visual,AllocNone);
		if(!XAllocColorCells(display,cmap,False,0,0,pixels,32*7+2))
			{
			printf("impossible\n");
			exit(1);
			}
		xc.red=xc.green=xc.blue=0;
		xc.pixel=32*7;
		XStoreColor(display,cmap,&xc);
		black=32*7;

		xc.red=xc.green=xc.blue=65535;
		xc.pixel=32*7+1;
		XStoreColor(display,cmap,&xc);
		white=32*7+1;
		}
	for(bl=0;bl<2;bl++)
	for(ve=0;ve<2;ve++)
	for(ro=0;ro<2;ro++)
	for(i=0;i<32;i++)
		{
		xc.red=i*ro*8*256;
		xc.green=i*ve*8*256;
		xc.blue=i*bl*8*256;
		if (gray) xc.red=xc.green=xc.blue=i*8*256;
		c=(ro+2*ve+4*bl)*32+i;
		if (c>31)	{
				xc.pixel=pixels[c-32];
				XStoreColor(display,cmap,&xc);
				}
		}
	}

	tools=XCreateSimpleWindow(display, root,0,0,128,400,1,white,black);
	XSetStandardProperties(display, tools, "Tools","Tools",0,
		argv,argc,NULL);
	if (modegraph==0)	XSetWindowColormap(display,tools,cmap);
	XSelectInput(display,tools,ExposureMask | ButtonPressMask);
	XMapWindow(display,tools);
	XMoveWindow(display,tools,10,50);


	dessin=XCreatePixmap(display,root,1024,768
				,DefaultDepth(display,screen));

	inimodel();
	afpara();

    for(i=0;i<2;i++)
	{
	win[i]=XCreateSimpleWindow(display, root,0,0,400,400,1,white,black);
	XSetStandardProperties(display, win[i], "View","View",0,
		argv,argc,NULL);
	if (modegraph==0)	XSetWindowColormap(display,win[i],cmap);
	XSelectInput(display,win[i],ExposureMask| ButtonPressMask
	       | ButtonMotionMask | StructureNotifyMask);
	XMapWindow(display,win[i]);
	XMoveWindow(display,win[i],158+i*420,50);

	pas[i]=&Pass[i];
	obs[i]=&Obs[i];
	rsph[i]=&Rsph[i];

	iniposition(obs[i],pas[i],rsph[i]);
	imagei(i);
	}

	copyobj();

	while(1)
	{
	XNextEvent(display,&ev);
	switch(ev.type)	{

	case Expose:
		i0=i1=it=0;
		do	{
			if ((ev.xany.window==win[0])&&(!i0))
				{
				imagei(0);
				i0=1;
				}
			if ((ev.xany.window==win[1])&&(!i1))
				{
				imagei(1);
				i1=1;
				}
			if ((ev.xany.window==tools)&&(!it))
				{
				affichetools();
				it=1;
				}
			}
		while(XCheckTypedEvent(display,Expose,&ev));

		break;

	case ButtonPress:
		xlm=ev.xbutton.x;
		ylm=ev.xbutton.y;
		state=ev.xbutton.button;
		i=-1;
		if (ev.xany.window==win[0]) i=0;
		if (ev.xany.window==win[1]) i=1;

		if (((ev.xbutton.state&(ShiftMask|ControlMask))==0)&&(i!=-1))
			{
			if (state==1)
				clickg(i,xlm-obs[i]->sx,obs[i]->sy-ylm);
			if (state==2)
				clickm(i,xlm-obs[i]->sx,obs[i]->sy-ylm);
			if (state==3)
				{
				depile();
				imagei(0);
				imagei(1);
				afcourant();
				}
			}
		if (i==-1)
			{
			i0=2;
			it=xlm/64+2*(ylm/40);
			switch (it)	{
			case 0 :
				newpnt(ev.xbutton.state);
				break;
			case 1 :
				effpnt(ev.xbutton.state);
				break;
			case 2 :
				newpol();
				break;
			case 3 :
				effpol();
				break;
			case 4 :
				empileall();
				i0=1;
				break;
			case 5 :
				videpile();
				i0=1;
				break;
			case 6 :
				chgcoord(ev.xbutton.state&ShiftMask);
				break;
			case 7 :
				if (state==3) setcol();
				else	chgcol();
				i0=1;
				break;
			case 8 :
				modecroix=1-modecroix;
				i0=1;
				break;
			case 12:
				if (nbnoeud==0)
					{
					copyobj();
					compil();
					}
					else
					recopyobj();
				break;
			case 13:
				photo(obs[1],pas[1],win[1]);
				i0=1;
				break;
			case 14:
				save();
				i0=0;
				break;
			case 15:
				merge();
				break;
			default:
				i0=0;
				break;	}
			if (i0)	{
				imagei(0);
				imagei(1);
				afcourant();
				if (i0==2) afpara();
				}
			}

		break;

	case MotionNotify:
		while(XCheckTypedEvent(display,MotionNotify,&ev));
		xm=ev.xbutton.x;
		ym=ev.xbutton.y;
		i0=1;
		if((ev.xbutton.state&(ShiftMask|ControlMask))==ShiftMask)
			{
			i=-1;
			if (ev.xany.window==win[0]) i=0;
			if (ev.xany.window==win[1]) i=1;
			if (i!=-1)
				{
				deplace(obs[i], pas[i], xm-xlm, ylm-ym
					, ev.xbutton.state, modedep, rsph[i]);
				imagei(i);
				}
			}
		if(ev.xbutton.state&ControlMask)
			{
			i0=5;
			deplacep((xm-xlm)/i0,(ylm-ym)/i0,ev.xbutton.state);
			imagei(0);
			imagei(1);
			afcourant();
			}
		xlm+=i0*((xm-xlm)/i0); ylm+=i0*((ym-ylm)/i0);
		break;

	case ConfigureNotify:
		i=-1;
		if (ev.xany.window==win[0]) i=0;
		if (ev.xany.window==win[1]) i=1;
	    if (i!=-1)
		{
		obs[i]->sx=ev.xconfigure.width/2;
		obs[i]->sy=ev.xconfigure.height/2;
		if (obs[i]->sx>maxsx) obs[i]->sx=maxsx;
		if (obs[i]->sy>maxsy) obs[i]->sy=maxsy;
		obs[i]->phi=obs[i]->sx/obs[i]->dist;
		obs[i]->psi=obs[i]->sy/obs[i]->dist;
		imagei(i);
		}
		break;

	default:
		break;

	}
	}
	}






